<style scoped>
.container {
  width: 300px;
}
.header {
  margin: 0;
  text-align: center;
}
h2,
p {
  margin: 0;
}
.flex-container-1 {
  display: flex;
  margin-top: 10px;
}
.flex-container-1 > div {
  text-align: left;
}
.flex-container-1 .right {
  text-align: right;
  width: 200px;
}
.flex-container-1 .left {
  width: 100px;
}
.flex-container {
  width: 300px;
  display: flex;
}
.flex-container > div {
  -ms-flex: 1; /* IE 10 */
  flex: 1;
}
ul {
  display: contents;
}
ul li {
  display: block;
}
hr {
  border-style: dashed;
}
a {
  text-decoration: none;
  text-align: center;
  padding: 10px;
  background: #00e676;
  border-radius: 5px;
  color: white;
  font-weight: bold;
}
</style>
<template>
  <Head title="Invoice" />
  
  <div class="container">
        <div class="header" style="margin-bottom: 30px;">
            <h2>Toko Wingko</h2>
            <span>Cimak Noid CENTER BLOK K5 NO. 21 Kota Tangerang</span>
        </div>
        <hr>
        <div class="flex-container-1 text-sm">
            <div class="left">
                <ul>
                    <li>No Order</li>
                    <li>Kasir</li>
                    <li>Tanggal</li>
                </ul>
            </div>
            <div class="right">
                <ul>
                    <li> {{ order.no_order }} </li>
                    <li> {{ order.cashier }} </li>
                    <li> {{ moment(order.created_at).format("ddd MMM DD, YYYY [at] HH:mm a") }} </li>
                </ul>
            </div>
        </div>
        <hr>
        
        <div class="flex-container text-sm" style="margin-bottom: 10px; text-align:right;">
            <div style="text-align: left;">Product</div>
            <div>Harga/Qty</div>
            <div>Total</div>
        </div>
         
        <div v-for="(item, i) in detail"  :key="i" class="flex-container text-sm" style="text-align: right;">
            <div style="text-align: left;">{{ item.qty }}x {{ item.menu_name }}</div>
            <div>Rp {{ item.menu_price }} </div>
            <div>Rp {{ item.total }} </div>
        </div>
        
        <hr>
        <div class="flex-container text-sm" style="text-align: right; margin-top: 10px;">
            <div></div>
            <div>
                <ul>
                    <li>PPN(%)</li>
                    <li>Grand Total</li>
                    <li>Pembayaran</li>
                    <li>Kembalian</li>
                </ul>
            </div>
            <div style="text-align: right;">
                <ul>
                    <li>10</li>
                    <li>{{ order.charge_value }} </li>
                    <li>{{ order.payment_value }}</li>
                    <li>{{ order.change_value }}</li>
                </ul>
            </div>
        </div>
        <hr>
        <div class="header text-sm" style="margin-top: 50px;">
            <h3>Terimakasih</h3>
            <p>Silahkan berkunjung kembali</p>
        </div>
    </div>
  
</template>

<script>
import Layout from "@/Layouts/App.vue";
import { Head } from "@inertiajs/inertia-vue3";
import { Link } from "@inertiajs/inertia-vue3";
import Icon from "@/Components/Icon";
import Input from "@/Components/Input.vue";
import Label from "@/Components/Label.vue";
import Button from "@/Components/Button.vue";
import Multiselect from "@suadelabs/vue3-multiselect";
import Pagination from "@/Components/Pagination.vue";
import moment from 'moment'

export default {
  components: {
    Layout,
    Head,
    Link,
    Icon,
    Button,
    Input,
    Label,
    Multiselect,
    Pagination,
  },
  props: {
    order: {
      type: Object,
    }, 
    detail: {
      type: Array,
    }, 
  },
  data() {
    return {
      form: this.$inertia.form({
        table_order: null,
        customer_name: null,
        customer_phone: null,
        type_payment: null,
        notes: null,
        cartItems: [],
        subTotal: 0,
        ppn: 10,
        charge_value: 0,
        payment_value: 0,
        change_value: 0,
        moment: null,
      }),
    };
  },
  beforeMount() {
    this.getCart();
    this.getSubtotal();
    this.getAllTotal();
    this.moment = moment;
  },
  methods: {
    store() {
      // this.form.post(this.route("order.store"));
      this.form.post(this.route("order.store"), {
        // preserveScroll: true,
        onSuccess: () => localStorage.setItem("cart", JSON.stringify([])),
      });
    },
    removeCart() {
      localStorage.setItem("cart", JSON.stringify([]));
    },
    getCart() {
      if (!localStorage.getItem("cart")) {
        localStorage.setItem("cart", JSON.stringify([]));
      }
      this.form.cartItems = JSON.parse(localStorage.getItem("cart"));
    },
    addtoCart(item) {
      let itemId = item.id;
      let menu = {
        id: item.id,
        name: item.name,
        price: item.price,
        qty: 1,
        cover: item.cover,
        total: item.price * 1,
      };

      let item_in_cart = this.form.cartItems.filter(function (menu) {
        return menu.id == itemId;
      })[0];

      if (!localStorage.getItem("cart")) {
        localStorage.setItem("cart", JSON.stringify([]));
      }

      const cartTempItems = JSON.parse(localStorage.getItem("cart"));

      if (item_in_cart === undefined) {
        cartTempItems.push(menu);
        localStorage.setItem("cart", JSON.stringify(cartTempItems));
        this.form.cartItems = JSON.parse(localStorage.getItem("cart"));
      } else {
        item_in_cart.qty++;
        item_in_cart.total = item_in_cart.price * item_in_cart.qty;
        localStorage.setItem("cart", JSON.stringify([]));
        localStorage.setItem("cart", JSON.stringify(this.form.cartItems));
      }
      this.getSubtotal();
      this.getAllTotal();
    },
    updateCart(type, menuId, index) {
      let item_in_cart = this.form.cartItems.filter(function (menu) {
        return menu.id == menuId;
      })[0];

      if (type === "add") {
        item_in_cart.qty++;
      } else if (type === "remove") {
        item_in_cart.qty--;
        if (item_in_cart.qty == 0) {
          this.deleteCart(index);
        }
      }

      item_in_cart.total = item_in_cart.price * item_in_cart.qty;

      localStorage.setItem("cart", JSON.stringify([]));
      localStorage.setItem("cart", JSON.stringify(this.form.cartItems));

      this.getSubtotal();
      this.getAllTotal();
    },
    deleteCart(i) {
      this.form.cartItems.splice(i, 1);
      localStorage.setItem("cart", JSON.stringify([]));
      localStorage.setItem("cart", JSON.stringify(this.form.cartItems));

      this.getSubtotal();
      this.getAllTotal();
    },
    getSubtotal() {
      let subTotal = 0;
      this.form.cartItems.forEach((cart) => {
        subTotal += cart.total;
      });

      this.form.subTotal = subTotal;
    },
    getAllTotal() {
      let percent = (this.form.ppn / 100) * this.form.subTotal;
      this.form.charge_value = parseInt(this.form.subTotal) + parseInt(percent);
      this.form.payment_value = this.form.charge_value;
      this.form.change_value = this.form.charge_value - this.form.payment_value;
    },
    changeCharge(value) {
      const v = parseInt(value, 10); // value from input is always string
      let totalCharge = v - parseInt(this.form.charge_value);
      if (!isNaN(totalCharge)) {
        this.form.change_value = totalCharge.toFixed(0);
      } else {
        this.form.change_value = 0;
      }
    },
    addPayment(value) {
      this.form.payment_value = value;
      this.changeCharge(value);
    },
    NumbersOnly(evt) {
      evt = evt ? evt : window.event;
      var charCode = evt.which ? evt.which : evt.keyCode;
      if (
        charCode > 31 &&
        (charCode < 48 || charCode > 57) &&
        charCode !== 46
      ) {
        evt.preventDefault();
      } else {
        return true;
      }
    },
    formatPrice(value) {
      let val = (value / 1).toFixed(2).replace(".", ",");
      return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
    },
  },
};
</script>
